<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" />
        <title>Mereo - Help</title>
        <style type="text/css">
            body {
                font-family: Verdana, Arial, Helvetica, sans-serif;
                font-size: 12px;
            }

            table {
                color: #333333;
            }

            td {
                vertical-align: top;
            }

            h1, h1 a {
                font-size: 32px;
                color: #FFFFDD;
                margin: 0;
            }

            h2, h2 a {
                font-size: 22px;
                margin: 15px 0 15px 0;
            }

            hr {
                height: 4px;
                background: #CCCCCC;
                border: 1px #2D5700 solid;
                margin-top: 20px;
            }

            a {
                font-family: Verdana, sans-serif;
                font-size: 12px;
                color: #0035AD;
                text-decoration: none;
            }

            a:visited {
                color: #660066;
            }

            a:hover {
                color: #FF6600;
                text-decoration: underline;
            }

            p {
                margin: 0;
                padding: 0;
            }

            #header_text {
                margin: 0;
                padding-left: 0.15em;
            }

            .qa {
                font-weight: bold;
                color: #444444;
            }

            .qa_box {
                float: left;
                width: 120px;
            }

            .qa_hr {
                background: #CCCCCC;
                border-color: #2D5700;
                width: 530px;
                margin: 0 0 20px 0;
            }

            .qa_main_box {
                border: 1px solid black;
                width: 540px;
                height: auto;
                padding: 5px;
                margin-bottom: 20px;
            }

            .qa_box_big {
                width: 400px;
                margin-left: 120px;
                margin-bottom: 10px;
                border: 1px #000000 solid;
                padding: 5px;
            }

            .qa_box_small {
                width: 250px;
                border: 1px #000000 dashed;
                margin-top: 10px;
                padding: 5px 5px 10px;
            }

            .qa_box_hr {
                margin: 0 0 15px;
                padding: 0;
                border-top: 1px #000000 solid;
                height: 1px;
                overflow: hidden;
            }

            .step_left {
                padding-right: 69px;
            }

            .step_right {
                border: 1px #000000 solid;
                padding: 5px;
            }

            .imgstep {
                margin: 10px 0 10px 0;
            }

            .header {
                 background-color: #6D95B5;
                 height: 80px;
                 border: 2px dashed #000000;
            }

            .toc {
                font-size: 14px;
                font-weight: bold;
            }

            .note {
                display: block;
                float: left;
                width: 115px;
                margin: 0 10px 0 3px;
                font-weight: bold;
            }

            .margin_bottom {
                margin-bottom: 15px;
            }

            .no_margin_topbottom {
                margin-top: 0;
                margin-bottom: 0;
            }

            .padding_top {
                padding-top: 15px;
            }

            .float_left {
                float: left;
            }

            .clear_both {
                clear: both;
            }
        </style>
    </head>

    <body>
    <div class="header">
        <img align="right" src="./helpfiles/logo.png" alt="Mereo" />
        <h1 id="header_text">Mereo User Guide</h1>
    </div>

    <h2>Table of Contents</h2>
    <div class="toc">
        <a href="#SYSREQ">1 - System Requirements</a><br />
        <a href="#PURPOSE">2 - Purpose</a><br />
        <a href="#HOWTO">3 - How To Setup A Server</a><br />
        <a href="#CMD">4 - How To Use The Commandline Interface</a><br />
        <a href="#STARTUP">5 - Mereo At System Startup</a><br />
        <a href="#FAV">6 - How To Use The Favorites</a><br />
        <a href="#ERRORPAGES">7 - Customizable Error Pages</a><br />
        <a href="#CFG_FORMAT">8 - Configuration File Format Specification</a><br />
        <a href="#CHARSET">9 - Character Sets</a><br />
        <a href="#DEFAULTS">10 - Default Settings</a><br />
        <a href="#FAQ">11 - FAQ (Frequently Asked Questions)</a><br />
        <ul class="no_margin_topbottom">
            <li><a href="#FAQ-css_problems">CSS problems</a></li>
            <li><a href="#FAQ-settings_file_cd">Using the settings file from CD</a></li>
            <li><a href="#FAQ-cd_autorun">CD Autorun</a></li>
            <li><a href="#FAQ-router_port_fwd">Router Port Forwarding</a></li>
            <li><a href="#FAQ-log_read_error">READ ERROR message in the log</a></li>
            <li><a href="#FAQ-custom_mime_types">Custom MIME types</a></li>
            <li><a href="#FAQ-maxthreads_notworking">The 'maximum number of threads' setting doesn't seem to work</a></li>
            <li><a href="#FAQ-prefs-defaults">How can all the preferences at once be reset to their defaults?</a></li>
            <li><a href="#FAQ-prefs-logmem_cant_change">It seems the 'log memory' setting can't be changed</a></li>
        </ul>
        <a href="#LICENSE">12 - License</a><br />
    </div>

    <hr />
    <h2><a name="SYSREQ" href="#SYSREQ">1 - System Requirements</a></h2>
    <ul class="no_margin_topbottom">
        <li>Windows 32-bit Operating System</li>
        <li>At least 16MB of free memory</li>
    </ul>

    <hr />
    <h2><a name="PURPOSE" href="#PURPOSE">2 - Purpose</a></h2>
    Mereo is designed to run under Windows 98/NT/2000/XP.<br />
    <br />
    It is optimized for low memory usage, even during file transfers.<br />

    <hr />
    <h2><a name="HOWTO" href="#HOWTO">3 - How To Setup A Server</a></h2>
    <table border="0" cellpadding="2" cellspacing="2">
    <tr>
        <td class="step_left"><strong>Step 1:</strong></td>
        <td><div class="step_right">
            Execute 'mereo.exe'.
        </div></td>
    </tr>
    <tr>
        <td class="step_left"><strong>Step 2:</strong></td>
        <td><div class="step_right">
            Click the menu 'Server'.
        </div></td>
    </tr>
    <tr>
        <td class="step_left"><strong>Step 3:</strong></td>
        <td><div class="step_right">
            Click the menu item 'Select Directory'.
        </div></td>
    </tr>
    <tr>
        <td class="step_left"><strong>Step 4:</strong></td>
        <td><div class="step_right">
            Browse for a directory you want to host.
        </div></td>
    </tr>
    <tr>
        <td class="step_left"><strong>Step 5:</strong></td>
        <td><div class="step_right">
            If you want viewers to be able to see the files in the directory<br />
            select 'Directory Browsing' (optional). This will show the files<br />
            in the directory if no 'index.html' or 'index.htm' file is found.
        </div></td>
    </tr>
    <tr>
        <td class="step_left"><strong>Step 6:</strong></td>
        <td><div class="step_right">
            Type in a port number or leave it at 80 (default).
        </div></td>
    </tr>
    <tr>
        <td class="step_left"><strong>Step 7:</strong></td>
        <td><div class="step_right">
            Click the menu 'Server'.
        </div></td>
    </tr>
    <tr>
        <td class="step_left"><strong>Step 8:</strong></td>
        <td><div class="step_right">
            Click the menu item 'Host'.
        </div></td>
    </tr>
    <tr>
        <td class="step_left"><strong>Step 9:</strong></td>
        <td><div class="step_right">
            If everything went fine, the tray-icon will change<br />
            its color and the status bar will state 'Server running'.
        </div></td>
    </tr>
    </table>
    <br />
    You can now minimize Mereo, it will stay visible in the tray-icon area. If<br />
    you double click the tray-icon, Mereo will be set to the foreground again.<br />
    If you then again double click the tray-icon, Mereo will hide itself.<br />
    <br />
    Right-click the tray-icon of Mereo to start, stop, restore or exit the server.<br />

    <hr />
    <h2><a name="CMD" href="#CMD">4 - How To Use The Commandline Interface</a></h2>
    The commandline interface supports the following commands:<br /><br />
    <table border="1px" cellpadding="4" cellspacing="2" width="700">
        <tr>
            <td width="110">-b [ADDRESS]</td>
            <td>Limits outside access to the specified address.<br /><br />
                (This can be handy when for example you only want a friend to download
                a file from you but not other leechers.)<br /><br />
                A space between the argument and [ADDRESS] <strong>is</strong> required.</td>
        </tr>
        <tr>
            <td width="110">-de</td>
            <td>Enables Directory Browsing</td>
        </tr>
        <tr>
            <td width="110">-p [NUMBER]</td>
            <td>Specifies the port to use for incoming connections.<br /><br />
                The valid port range is 0 - 65536 (i.e. any number between them).<br /><br />
                A space between the argument and [NUMBER] <strong>is</strong> required.</td>
        </tr>
        <tr>
            <td width="110">-h [DIRECTORY]</td>
            <td>Specifies the directory to use as root.
                If there is a space in the path (like with "C:\Documents and Settings", then you
                need to insert a quote (" character) before and after the path, but it's not necessary
                with a path like "C:\WEBROOT", because there is no space in it.
                <br /><br />
                A valid path can be a relative path like 'WEBROOT', which would mean a directory called
                'WEBROOT' exists in the directory where 'mereo.exe' is located.
                <br /><br />
                Or a valid path can be an absolute path like 'C:\WEBROOT'.<br />
                <br />
                If this argument is specified, Mereo will automatically start
                hosting (only if the path specified is valid).<br />
                <br />
                If you want to host the directory where Mereo itself is located, you can easily
                use the -h parameter like this: '-h .\'<br />
                The <strong>.\</strong> part will make Mereo host the relative path <strong>.\</strong>
                which is the directory of 'mereo.exe' itself.<br />
                <br />
                A space between the argument and [DIRECTORY] <strong>is</strong> required.</td>
        </tr>
        <tr>
            <td width="110">-hide</td>
            <td>Hides the Mereo into the system tray at startup.</td>
        </tr>
    </table>

    <br />
    Please check the batch files in the 'batch' directory for examples on how to use the
    commandline interface.

    <hr />
    <h2><a name="STARTUP" href="#STARTUP">5 - Mereo At System Startup</a></h2>
    <table border="0" cellpadding="2" cellspacing="2">
    <tr>
        <td class="step_left"><strong>Step 1:</strong></td>
        <td><div class="step_right">
            Check the box 'Auto-start at Windows logon'.<br />
        </div></td>
    </tr>
    <tr>
        <td class="step_left"><strong>Step 2:</strong></td>
        <td><div class="step_right">
            Enter the desired configuration for Mereo.<br />
        </div></td>
    </tr>
    <tr>
        <td class="step_left"><strong>Step 3:</strong></td>
        <td><div class="step_right">
            Press 'Finish'.
        </div></td>
    </tr>
    </table>

    <hr />
    <h2><a name="FAV" href="#FAV">6 - How To Use The Favorites</a></h2>
    <table border="0" cellpadding="2" cellspacing="2">
    <tr>
        <td class="step_left"><strong>Step 1:</strong></td>
        <td><div class="step_right">
            Click 'Add Favorite' from the menu 'Favorites'.<br />
        </div></td>
    </tr>
    <tr>
        <td class="step_left"><strong>Step 2:</strong></td>
        <td><div class="step_right">
            Enter the desired name as alias for the webroot.<br />
            Then enter the full (or relative from directory of 'mereo.exe')<br />
            path to the webroot.<br />
            <br />
            If you do not specify a port, the default HTTP port (80) will<br />
            be used.<br />
            <br />
            Turn on the Directory Browsing feature if you want users to be<br />
            able to view the contents of the directories if no 'index.htm' or<br />
            'index.html' is found.<br />
            <img class="imgstep" src="./helpfiles/step6_2.png" alt="Step 2 Screenshot" />
        </div></td>
    </tr>
    <tr>
        <td class="step_left"><strong>Step 3:</strong></td>
        <td><div class="step_right">
            Now you can use the favorite:<br />
            <img class="imgstep" src="./helpfiles/step6_3.png" alt="Step 4 Screenshot" />
        </div></td>
    </tr>
    </table>

    <hr />
    <h2><a name="ERRORPAGES" href="#ERRORPAGES">7 - Customizable Error Pages</a></h2>
    <div class="clear_both">
        You can use customized error pages for the error code range 400-501.<br />
        In the root directory where 'mereo.exe' resides, create a subdirectory<br />
        called 'errorpages'. In there put the error page, which should be called:<br />
        {ERROR_CODE}.html (for example '404.html')<br />
        <br />
        It is recommended to use inline styles in the error pages.
    </div>

    <hr />
    <h2><a name="CFG_FORMAT" href="#CFG_FORMAT">8 - Configuration File Format Specification</a></h2>
    <div class="note">NOTE:</div>
    <div class="float_left">
        The line endings of the 'mereo.cfg' file must be in Windows<br />
        format, that means one Carriage Return followed by a Line Feed.<br />
        In the hexadecimal numbering system, this sequence is known as<br />
        0x0D followed by 0x0A
    </div>

    <div class="clear_both padding_top"></div>
    <div class="note">Example File:</div>
    <div class="float_left">
        <div class="step_right">
            Charset=ISO-8859-1<br />
            <br />
            [Favorite1]<br />
            Name=fav1<br />
            Path=c:\windows<br />
            <br />
            [Favorite2]<br />
            Name=fav2<br />
            Path=c:\windows\system<br />
            Port=22<br />
            DirectoryBrowsing=true<br />
            BindAddress=10.0.0.2<br />
            <br />
        </div>
    </div>
    <div class="clear_both"></div>

    <hr />
    <h2><a name="CHARSET" href="#CHARSET">9 - Character Sets</a></h2>
    <div class="note">NOTE:</div>
    <div class="float_left">
        At the moment there is one known problem with the 'ISO-8859-1'<br />
        character set and the Directory Browsing feature, please set<br />
        the character set to 'GBK' to prevent the layout from cluttering.
    </div>

    <div class="clear_both padding_top"></div>

    <div class="note">Character Sets:</div>
    <div class="float_left">
        ISO-8859-1 <i>(standard)</i><br />
        GBK <i>(Chinese)</i><br />
        Shift JIS <i>(Japanese)</i><br />
        EUC-KR <i>(Korean)</i><br />

        <br />
        Further reference: <a href="http://en.wikipedia.org/wiki/Character_encoding">http://en.wikipedia.org/wiki/Character_encoding</a><br />

        <br />
        <i>
            If needed, this list will be expanded later.<br />
            <a href="mailto:bughunter2@users.sourceforge.net">Send me an e-mail if you want a character set to be added.</a>
        </i>
    </div>
    <div class="clear_both"></div>

    <hr />
    <h2><a name="DEFAULTS" href="#DEFAULTS">10 - Default Settings</a></h2>
    <div class="float_left">
        <p class="margin_bottom">
            <strong>
                The listing below describes the default values used when a
                setting could not be found in the configuration file.
            </strong>
        </p>

        <p>
            Charset=ISO-8859-1
        </p>
        <p>
            DirBrowseForce=0
        </p>
        <p>
            LogEnable=1
        </p>
        <p>
            MaxThreads=1000
        </p>
        <p>
            LogMem=1048576
        </p>
        <p>
            UpdateInterval=0
        </p>
        <p>
            UpdateCheckAtProgramStart=1
        </p>
    </div>

    <div class="clear_both"></div>

    <hr />
    <h2><a name="FAQ" href="#FAQ">10 - FAQ (Frequently Asked Questions)</a></h2>
    <!-- CSS problems Q/A -->
    <a name="FAQ-css_problems"></a><div class="qa_main_box">
        <h2>CSS problems</h2>
        <hr class="qa_hr" align="left" />
        <div class="qa_box"><span class="qa">Question:</span></div>
        <div class="qa_box_big">
            I'm testing my website (hosted with Mereo) and my browser
            (for example Firefox or Internet Explorer) does not load my CSS
            stylesheet correctly, what can I do?
        </div>

        <div class="qa_box"><span class="qa">Answer:</span></div>
        <div class="qa_box_big">
            The Content Type for the '.css' file extension is not correctly set on the
            server. Please run 'files/css_patch.reg' at the server computer to make sure
            the Content Type header of a HTTP response will be set to 'text/css'.
        </div>
    </div>
    <!-- End of CSS problems Q/A -->

    <!-- Settings file from CD Q/A -->
    <a name="FAQ-settings_file_cd"></a><div class="qa_main_box">
        <h2>Using the settings file from CD</h2>
        <hr class="qa_hr" align="left" />
        <div class="qa_box"><span class="qa">Question:</span></div>
        <div class="qa_box_big">
            I want to run Mereo from a CD, can the 'mereo.cfg' still be used?
        </div>

        <div class="qa_box"><span class="qa">Answer:</span></div>
        <div class="qa_box_big">
            Yes and no. The 'mereo.cfg' file will be read, parsed and used in the favorites menu,
            but you can't add new favorites when running from a CD or when 'mereo.cfg' is
            set to READ-ONLY.
        </div>
    </div>
    <!-- End of Settings file from CD Q/A -->

    <!-- CD Autorun Q/A -->
    <a name="FAQ-cd_autorun"></a><div class="qa_main_box">
        <h2>CD Autorun</h2>
        <hr class="qa_hr" align="left" />
        <div class="qa_box"><span class="qa">Question:</span></div>
        <div class="qa_box_big">
            I want to automatically run Mereo when inserting my CD with 'mereo.exe'
            on it, is this possible?
        </div>

        <div class="qa_box"><span class="qa">Answer:</span></div>
        <div class="qa_box_big">
            Definately. If you have some experience with 'autorun.inf' files on CD's you can
            create a batch file (or pick one from the 'batch' directory included in the package)
            and specify the arguments for Mereo.<br />
            <br />
            After you have done that, create a file called 'autorun.inf' and put the following
            information in it:
            <div class="qa_box_small">
                <strong>autorun.inf:</strong>
                <hr class="qa_box_hr" />
                [autorun]<br />
                open=run.bat
            </div>
            <br />
            You also have to edit the example batch file (of your choice) to startup Mereo<br />
            with the -hide argument. An example 'run.bat':
            <div class="qa_box_small">
                <strong>run.bat:</strong>
                <hr class="qa_box_hr" />
                mereo.exe -de -h .\web -p 8080 -hide<br />
            </div>
            <br />
            This will make Mereo startup <strong>hidden</strong> with <strong>Directory Browsing enabled</strong>,
            hosting the directory <strong>.\web</strong> and using <strong>port 8080</strong>.<br />
            <br />
            Now you have two files called 'autorun.inf' and 'run.bat', put them both in the root
            directory of the CD.
        </div>
    </div>
    <!-- End of CD Autorun Q/A -->

    <!-- Router Port Forwarding Q/A -->
    <a name="FAQ-router_port_fwd"></a><div class="qa_main_box">
        <h2>Router Port Forwarding</h2>
        <hr class="qa_hr" align="left" />
        <div class="qa_box"><span class="qa">Question:</span></div>
        <div class="qa_box_big">
            Other users can't view my website, how come?
        </div>

        <div class="qa_box"><span class="qa">Answer:</span></div>
        <div class="qa_box_big">
            One of the possible causes is that you don't use the default HTTP port 80. Please
            verify this.<br /><br />

            Another possible cause is that your connection is behind a router, if you have access
            to the router, please verify port 80 is forwarded to the local IP address. Usually
            you can find this information under a button 'Port Forwarding' or 'Virtual Server' etc.
        </div>
    </div>
    <!-- End of Router Port Forwarding Q/A -->

    <!-- Log READ ERROR Q/A -->
    <a name="FAQ-log_read_error"></a><div class="qa_main_box">
        <h2>READ ERROR message in the log</h2>
        <hr class="qa_hr" align="left" />
        <div class="qa_box"><span class="qa">Question:</span></div>
        <div class="qa_box_big">
            I see a 'READ ERROR' message in my log, what is this?
        </div>

        <div class="qa_box"><span class="qa">Answer:</span></div>
        <div class="qa_box_big">
            A file requested by the client was probably in use or locked, or the computer
            was low on memory at the time of the request. You should both check whether this
            happens often and check if the computer is low on memory.
        </div>
    </div>
    <!-- Log READ ERROR Q/A -->

    <!-- Custom MIME types Q/A -->
    <a name="FAQ-custom_mime_types"></a><div class="qa_main_box">
        <h2>Custom MIME types</h2>
        <hr class="qa_hr" align="left" />
        <div class="qa_box"><span class="qa">Question:</span></div>
        <div class="qa_box_big">
            Can I change the MIME type for a specific file type?
        </div>

        <div class="qa_box"><span class="qa">Answer:</span></div>
        <div class="qa_box_big">
            Yes you can. Use a registry editor (for example Windows' 'regedit.exe') and browse
            to the key HKEY_CLASSES_ROOT\.&lt;FILE_TYPE_HERE&gt;.<br />
            <br />
            There you will see a key named "Content Type". You can change that key to the desired value.<br />
            <br />
            For example:
            HKEY_CLASSES_ROOT\.wmv contains the "Content Type" key for the file type ".WMV".
        </div>
    </div>
    <!-- Custom MIME types Q/A -->

    <!-- Max threads Q/A -->
    <a name="FAQ-maxthreads_notworking"></a><div class="qa_main_box">
        <h2>The 'maximum number of threads' setting doesn't seem to work</h2>
        <hr class="qa_hr" align="left" />
        <div class="qa_box"><span class="qa">Question:</span></div>
        <div class="qa_box_big">
            When checking the number of threads running for the Mereo process, I've
            spotted that more threads are running than the number I've set in the preferences.
        </div>

        <div class="qa_box"><span class="qa">Answer:</span></div>
        <div class="qa_box_big">
            Sometimes it can occur that more threads are running than the maximum number of threads
            that you've configured in the preferences. The difference between the actual number of
            threads running and the configuration shouldn't differ a lot. It occurs because the
            'maximum number of threads' setting only controls how much threads are actually used for
            connection handling. Some other threads might run because the Windows API (Application
            Programming Interface) started them.
        </div>
    </div>
    <!-- Max threads Q/A -->

    <!-- Reset Preferences Q/A -->
    <a name="FAQ-prefs-defaults"></a><div class="qa_main_box">
        <h2>How can all the preferences at once be reset to their defaults?</h2>
        <hr class="qa_hr" align="left" />
        <div class="qa_box"><span class="qa">Question:</span></div>
        <div class="qa_box_big">
            How can all the preferences at once be reset to their defaults?
        </div>

        <div class="qa_box"><span class="qa">Answer:</span></div>
        <div class="qa_box_big">
            You have to backup/(re)move/rename the file 'mereo.cfg'.
        </div>
    </div>
    <!-- Reset Preferences Q/A -->

    <!-- Log Mem Q/A -->
    <a name="FAQ-prefs-logmem_cant_change"></a><div class="qa_main_box">
        <h2>It seems the 'log memory' setting can't be changed</h2>
        <hr class="qa_hr" align="left" />
        <div class="qa_box"><span class="qa">Question:</span></div>
        <div class="qa_box_big">
            In the Preferences dialog; when trying to change the amount of memory used for the log,
            it seems changing the option is disabled.
        </div>

        <div class="qa_box"><span class="qa">Answer:</span></div>
        <div class="qa_box_big">
            You temporarily have to stop hosting, this enables changing the setting. This is done on purpose.
            After that, the settings dialog has to be closed and re-opened to be able to change the setting.
        </div>
    </div>
    <!-- Log Mem Q/A -->

<hr />

<a name="LICENSE"></a>
<h2>License</h2>
<pre>
Mereo - An HTTP server.
Copyright (C) 2008  Jelle Geerts

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
</pre>
    </body>
</html>
